'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var nodePath = require('path');
var helperModuleImports = require('@babel/helper-module-imports');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

var nodePath__default = /*#__PURE__*/_interopDefault(nodePath);

function plugin() {
  return {
    visitor: {
      TSAsExpression(asExpressionPath) {
        let expressionPath = asExpressionPath.get("expression");
        if (expressionPath.node.type === "TaggedTemplateExpression" && expressionPath.node.tag.type === "Identifier" && expressionPath.node.tag.name === "gql" && asExpressionPath.node.type === "TSAsExpression" && asExpressionPath.node.typeAnnotation.type === "TSImportType") {
          expressionPath.replaceWith(helperModuleImports.addNamed(expressionPath, "document", asExpressionPath.node.typeAnnotation.argument.value, {
            nameHint: nodePath__default["default"].basename(asExpressionPath.node.typeAnnotation.argument.value)
          }));
        }
      }
    }
  };
}

exports["default"] = plugin;
